﻿using Infragistics.Win.UltraWinGrid;
using System;
using System.Data;
using System.Windows.Forms;

namespace KB4939_SampleApp
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ultraGrid1.DataSource = GetData();
        }

        private DataSet GetData()
        {
            DataSet ds = new DataSet();

            // ==== 親テーブル ===
            DataTable prefectureTable = ds.Tables.Add("Prefecture");

            // 列
            prefectureTable.Columns.Add("PrefCode", typeof(String));
            prefectureTable.Columns.Add("PrefName", typeof(String));

            // 行
            prefectureTable.Rows.Add(new object[] { "1", "北海道" });
            prefectureTable.Rows.Add(new object[] { "2", "青森県" });
            prefectureTable.Rows.Add(new object[] { "3", "岩手県" });
            prefectureTable.Rows.Add(new object[] { "4", "宮城県" });
            prefectureTable.Rows.Add(new object[] { "5", "秋田県" });
            prefectureTable.Rows.Add(new object[] { "6", "山形県" });
            prefectureTable.Rows.Add(new object[] { "7", "福島県" });
            prefectureTable.Rows.Add(new object[] { "8", "茨城県" });
            prefectureTable.Rows.Add(new object[] { "9", "栃木県" });
            prefectureTable.Rows.Add(new object[] { "10", "群馬県" });
            prefectureTable.Rows.Add(new object[] { "11", "埼玉県" });
            prefectureTable.Rows.Add(new object[] { "12", "千葉県" });
            prefectureTable.Rows.Add(new object[] { "13", "東京都" });
            prefectureTable.Rows.Add(new object[] { "14", "神奈川県" });
            prefectureTable.Rows.Add(new object[] { "15", "新潟県" });
            prefectureTable.Rows.Add(new object[] { "16", "富山県" });
            prefectureTable.Rows.Add(new object[] { "17", "石川県" });
            prefectureTable.Rows.Add(new object[] { "18", "福井県" });
            prefectureTable.Rows.Add(new object[] { "19", "山梨県" });
            prefectureTable.Rows.Add(new object[] { "20", "長野県" });
            prefectureTable.Rows.Add(new object[] { "21", "岐阜県" });
            prefectureTable.Rows.Add(new object[] { "22", "静岡県" });
            prefectureTable.Rows.Add(new object[] { "23", "愛知県" });
            prefectureTable.Rows.Add(new object[] { "24", "三重県" });
            prefectureTable.Rows.Add(new object[] { "25", "滋賀県" });
            prefectureTable.Rows.Add(new object[] { "26", "京都府" });
            prefectureTable.Rows.Add(new object[] { "27", "大阪府" });
            prefectureTable.Rows.Add(new object[] { "28", "兵庫県" });
            prefectureTable.Rows.Add(new object[] { "29", "奈良県" });
            prefectureTable.Rows.Add(new object[] { "30", "和歌山県" });
            prefectureTable.Rows.Add(new object[] { "31", "鳥取県" });
            prefectureTable.Rows.Add(new object[] { "32", "島根県" });
            prefectureTable.Rows.Add(new object[] { "33", "岡山県" });
            prefectureTable.Rows.Add(new object[] { "34", "広島県" });
            prefectureTable.Rows.Add(new object[] { "35", "山口県" });
            prefectureTable.Rows.Add(new object[] { "36", "徳島県" });
            prefectureTable.Rows.Add(new object[] { "37", "香川県" });
            prefectureTable.Rows.Add(new object[] { "38", "愛媛県" });
            prefectureTable.Rows.Add(new object[] { "39", "高知県" });
            prefectureTable.Rows.Add(new object[] { "40", "福岡県" });
            prefectureTable.Rows.Add(new object[] { "41", "佐賀県" });
            prefectureTable.Rows.Add(new object[] { "42", "長崎県" });
            prefectureTable.Rows.Add(new object[] { "43", "熊本県" });
            prefectureTable.Rows.Add(new object[] { "44", "大分県" });
            prefectureTable.Rows.Add(new object[] { "45", "宮崎県" });
            prefectureTable.Rows.Add(new object[] { "46", "鹿児島県" });
            prefectureTable.Rows.Add(new object[] { "47", "沖縄県" });

            // プラマリーキー
            prefectureTable.PrimaryKey = new DataColumn[] { prefectureTable.Columns["PrefCode"] };


            // ==== 子テーブル ====
            DataTable personTable = ds.Tables.Add("Person");

            // 列
            personTable.Columns.Add("ID", typeof(int));
            personTable.Columns.Add("Name", typeof(String));
            personTable.Columns.Add("PrefCode", typeof(String));
            personTable.Columns.Add("Prefecture", typeof(String));
            personTable.Columns.Add("Address", typeof(String));
            personTable.Columns.Add("Birthday", typeof(DateTime));
            personTable.Columns.Add("BloodType", typeof(String));

            // Rows
            personTable.Rows.Add(new object[] { 1, "相田 早希", "4", "宮城県", "仙台市太白区", "1934/09/08", "O" });
            personTable.Rows.Add(new object[] { 2, "冨田 結衣", "29", "奈良県", "大和高田市", "1996/07/22", "B" });
            personTable.Rows.Add(new object[] { 3, "高山 御喜家", "46", "鹿児島県", "大島郡瀬戸内町", "1993/11/02", "O" });
            personTable.Rows.Add(new object[] { 4, "溝口 萌", "32", "島根県", "安来市", "1959/06/17", "O" });
            personTable.Rows.Add(new object[] { 5, "高井 智博", "13", "東京都", "国分寺市", "1963/06/13", "B" });
            personTable.Rows.Add(new object[] { 6, "田崎 藤奈", "42", "長崎県", "松浦市", "1998/08/19", "B" });
            personTable.Rows.Add(new object[] { 7, "栗田 孝明", "35", "山口県", "萩市", "1948/12/31", "O" });
            personTable.Rows.Add(new object[] { 8, "富田 千咲", "26", "京都府", "京都市北区", "1950/01/19", "A" });
            personTable.Rows.Add(new object[] { 9, "佐川 尚司", "5", "秋田県", "にかほ市", "1982/02/04", "B" });
            personTable.Rows.Add(new object[] { 10, "北田 和徳", "33", "岡山県", "高梁市", "1932/11/05", "AB" });

            // プライマリキー
            personTable.PrimaryKey = new DataColumn[] { personTable.Columns["ID"] };


            // リレーション
            ds.Relations.Add(new DataRelation("relation1", prefectureTable.Columns["PrefCode"], personTable.Columns["PrefCode"]));


            return ds;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            int rowsCount = 0;
            int groupByRowsCount = 0;

            // ヘルパーメソッドを呼び出します
            TraverseAllRowsHelper(this.ultraGrid1.Rows, ref rowsCount, ref groupByRowsCount);

            MessageBox.Show("UltraGrid の行数: " + rowsCount.ToString() + " グループ化行: " + groupByRowsCount.ToString());
        }

        private void TraverseAllRowsHelper(RowsCollection rows, ref int rowsCount, ref int groupByRowsCount)
        {
            foreach (UltraGridRow row in rows)
            {
                if (row is UltraGridGroupByRow)
                {
                    UltraGridGroupByRow groupByRow = (UltraGridGroupByRow)row;
                    groupByRowsCount++;
                }
                else
                {
                    rowsCount++;
                }

                if (null != row.ChildBands)
                {
                    foreach (UltraGridChildBand childBand in row.ChildBands)
                    {
                        this.TraverseAllRowsHelper(childBand.Rows, ref rowsCount, ref groupByRowsCount);
                    }
                }
            }
        }
    }
}
